-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

--Electrics streams and sound management for the central tire inflation system by TrackpadUser

local M = {}

local function onReset()
  electrics.values['pressureCoef'] = 1
  electrics.values['pressure_input'] = 0
end

local function updateGFX(dt) 
	--Changes the pressure coefficient for the tire inflation based on user input.
	--You can adjust the speed of the variation by changing the number after "DT". Higher = faster change.
  electrics.values['pressureCoef'] = math.min(1, math.max(0, (electrics.values['pressureCoef']+ electrics.values['pressure_input'] * dt * 0.25))) 
end

local function raiseTirePressure(value)
  electrics.values.pressure_input = value
end

local function lowerTirePressure(value)
  electrics.values.pressure_input = value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.raiseTirePressure = raiseTirePressure
M.lowerTirePressure = lowerTirePressure


M.initSounds = initSounds
M.resetSounds = resetSounds

return M
