local M = {}

local sfxprofilecounter = 0 -- local counter to enumerate the profiles without collisions, do not reset ever

local lastCamPos = nil
local isCameraInside = false

local pressureRaiseSound = nil
local pressureLowerSound = nil

local soundObj = {}
soundObj.__index = soundObj

abs = math.abs
min = math.min
max = math.max

local function findNodeCid(name)
  for _,node in pairs(v.data.nodes) do
      if node.name == name then return node.cid end
  end
  return -1
end

local function onInit()
      local doorNode = findNodeCid("refup")
      pressureRaiseSound = obj:createSFXSource( "event:>Vehicle>Pneumatics>Suspension_Up", "AudioDefaultLoop3D", "airdooropen", doorNode)
      pressureLowerSound = obj:createSFXSource( "event:>Vehicle>Pneumatics>Suspension_Down", "AudioDefaultLoop3D", "airdoorclose", doorNode)
end

local function stopInflationSounds()
    doorSoundPlaying = false
	obj:stopSFX(pressureLowerSound)
	obj:stopSFX(pressureRaiseSound)
end

local function onReset()
	stopInflationSounds()
end

local airHornVolSmooth = 0
local dtcounter = 0
local isPlaying = false
local function updateGFX(dt)
  -- update door stuff  
  
	if not isPlaying then
		if electrics.values['pressure_input'] > 0 then
			obj:setVolume(pressureRaiseSound, 1)
			obj:cutSFX(pressureRaiseSound)
			obj:playSFX(pressureRaiseSound)
			isPlaying = true
		elseif electrics.values['pressure_input'] < 0 then
			obj:setVolume(pressureLowerSound, 1)
			obj:cutSFX(pressureLowerSound)
			obj:playSFX(pressureLowerSound)
			isPlaying = true
		end
	end
	
	if isPlaying and (electrics.values['pressure_input'] == 0 or electrics.values['pressureCoef'] == 1 or electrics.values['pressureCoef'] == 0) then
		stopInflationSounds()
		isPlaying = false
    end
	
end

-- public interface
M.onInit      = onInit
M.onReset     = onReset
M.updateGFX = updateGFX

M.cameraPosCallback = cameraPosCallback

return M